diff --git a/test/integration/tui_new_idea_attachments_smoke_test.rb b/test/integration/tui_new_idea_attachments_smoke_test.rb
index 46bdf21..dea98e0 100644
--- a/test/integration/tui_new_idea_attachments_smoke_test.rb
+++ b/test/integration/tui_new_idea_attachments_smoke_test.rb
@@ -129,7 +129,7 @@ class TuiNewIdeaAttachmentsSmokeTest < Minitest::Test
           end
         end
 
-        task = Dir[File.join(dir, ".hive-state", "stages", "1-inbox", "bug-here-*")].first
+        task = Dir[File.join(dir, ".hive", "stages", "1-inbox", "bug-here-*")].first
         refute_nil task, "rich TUI submit must create an inbox task"
         idea = File.read(File.join(task, "idea.md"))
         assert_includes idea, "bug here ![](assets/bug-1.png), on mobile looks like ![](assets/bug-2.png) and desktop ![](assets/bug-3.png)"
@@ -141,13 +141,13 @@ class TuiNewIdeaAttachmentsSmokeTest < Minitest::Test
 
         # Plan / smoke-test contract pin: `git commit` must capture
         # `idea.md` plus every `assets/bug-N.png`, not just the
-        # markdown. The commit lands in the `.hive-state` git repo
+        # markdown. The commit lands in the `.hive` git repo
         # (separate worktree), so query that one, not the project
         # root. A regression where the TUI rich-submit `git add`s
         # only idea.md would silently break the multimodal handoff —
         # the brainstorm subprocess gets the asset arguments but the
         # commit history has nothing to back them up.
-        hive_state_dir = File.join(dir, ".hive-state")
+        hive_state_dir = File.join(dir, ".hive")
         git_files = `git -C #{hive_state_dir} log -1 --name-only --pretty=format: HEAD`
           .lines.map(&:chomp).reject(&:empty?)
         assert(
@@ -162,7 +162,7 @@ class TuiNewIdeaAttachmentsSmokeTest < Minitest::Test
           )
         end
 
-        target = File.join(dir, ".hive-state", "stages", "2-brainstorm", File.basename(task))
+        target = File.join(dir, ".hive", "stages", "2-brainstorm", File.basename(task))
         FileUtils.mv(task, target)
         brainstorm_md = File.join(target, "brainstorm.md")
         log_dir = Dir.mktmpdir("hive-fake-claude")
diff --git a/test/integration/tui_new_idea_attachments_test.rb b/test/integration/tui_new_idea_attachments_test.rb
index 2af2ee7..108c305 100644
--- a/test/integration/tui_new_idea_attachments_test.rb
+++ b/test/integration/tui_new_idea_attachments_test.rb
@@ -60,7 +60,7 @@ class TuiNewIdeaAttachmentsTest < Minitest::Test
         assert_nil bubble.hive_model.new_idea_staging_dir
         refute File.exist?(staging_dir), "successful rich submit must clean the composer staging dir"
 
-        glob = Dir[File.join(dir, ".hive-state", "stages", "1-inbox", "first-middle-*")]
+        glob = Dir[File.join(dir, ".hive", "stages", "1-inbox", "first-middle-*")]
         assert_equal 1, glob.size
         idea = File.read(File.join(glob.first, "idea.md"))
         assert_includes idea, "first ![](assets/bug-1.png) middle ![](assets/bug-2.png)"
@@ -87,7 +87,7 @@ class TuiNewIdeaAttachmentsTest < Minitest::Test
 
         capture_io { bubble.update(Hive::Tui::Messages::NEW_IDEA_SUBMITTED) }
 
-        glob = Dir[File.join(dir, ".hive-state", "stages", "1-inbox", "task-*")]
+        glob = Dir[File.join(dir, ".hive", "stages", "1-inbox", "task-*")]
         assert_equal 1, glob.size
         idea = File.read(File.join(glob.first, "idea.md"))
         assert_includes idea, "![](assets/bug-1.png)"
diff --git a/test/integration/tui_subprocess_test.rb b/test/integration/tui_subprocess_test.rb
index 34ad39c..e40b11d 100644
--- a/test/integration/tui_subprocess_test.rb
+++ b/test/integration/tui_subprocess_test.rb
@@ -312,6 +312,13 @@ class TuiSubprocessDispatchBackgroundTest < Minitest::Test
   end
 
   def test_concurrent_dispatches_run_in_parallel
+    # pgrep-based child reaping requires the procps tooling; stripped CI
+    # containers without it would otherwise crash the suite from an
+    # uncaught thread exception.
+    has_pgrep = ENV.fetch("PATH", "").split(File::PATH_SEPARATOR)
+                   .any? { |d| File.executable?(File.join(d, "pgrep")) }
+    skip("pgrep not available in this environment") unless has_pgrep
+
     # Two slow children, dispatched back-to-back. If `dispatch_background`
     # is truly non-blocking, both finish in ~max(t1, t2), not t1 + t2.
     ENV["HIVE_TUI_FAKE_BLOCK"] = "1"
@@ -324,7 +331,12 @@ class TuiSubprocessDispatchBackgroundTest < Minitest::Test
     # Kill any blocking child after a brief moment so the reapers can fire.
     killer = Thread.new do
       sleep 0.3
-      `pgrep -f tui-fake-child`.split.each do |pid|
+      pids = begin
+        `pgrep -f tui-fake-child`.split
+      rescue StandardError
+        []
+      end
+      pids.each do |pid|
         Process.kill("TERM", pid.to_i)
         pids_mutex.synchronize { pids_killed << pid.to_i }
       rescue Errno::ESRCH
diff --git a/test/packaging/install_test.sh b/test/packaging/install_test.sh
new file mode 100755
index 0000000..86d39f8
--- /dev/null
+++ b/test/packaging/install_test.sh
@@ -0,0 +1,111 @@
+#!/usr/bin/env bash
+# test/packaging/install_test.sh — offline install.sh contract checks
+# (plan U10 scenarios 1, 3, 4, 5) using a local fixture release dir.
+#
+#   1. install → --version works → --uninstall leaves config/state intact
+#   3. PATH conflict stub → installs as hv
+#   4. checksum mismatch (tampered tarball) → hard fail, zero files written
+#   5. HIVE_VERSION pin honored
+set -euo pipefail
+
+SCRIPT_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)"
+REPO_ROOT="$(cd "$SCRIPT_DIR/../.." && pwd)"
+INSTALL_SH="$REPO_ROOT/packaging/install.sh"
+
+TMP="$(mktemp -d "${TMPDIR:-/tmp}/hive-install-test.XXXXXX")"
+trap 'rm -rf "$TMP"' EXIT
+
+FAKE_RELEASE="$TMP/releases"
+SANDBOX_HOME="$TMP/home"
+mkdir -p "$FAKE_RELEASE" "$SANDBOX_HOME"
+export HOME="$SANDBOX_HOME"
+export XDG_CONFIG_HOME="$SANDBOX_HOME/.config"
+
+pass() { printf 'ok - %s\n' "$*"; fail_count=$((fail_count)); }
+assert_file() { [[ -e "$1" ]] || { printf 'FAIL: expected file %s\n' "$1" >&2; exit 1; }; pass "file exists $2"; }
+
+run_installer() {
+  env -u HIVE_HOME \
+    HIVE_VERSION="${HIVE_PIN:-v0.9.9}" \
+    HIVE_RELEASE_BASE="$FAKE_RELEASE" \
+    HIVE_INSTALL_APP_DIR="$SANDBOX_HOME/.local/share/hive" \
+    HIVE_INSTALL_BIN_DIR="$SANDBOX_HOME/.local/bin" \
+    bash "$INSTALL_SH"
+}
+
+build_fixture_release() {
+  local payload="$TMP/hive-v0.9.9-linux-x86_64"
+  mkdir -p "$payload/bin" "$payload/share/hive/lib"
+  # Minimal self-contained tree whose bin/hive responds to --version via sh.
+  cat > "$payload/bin/hive" <<LAUNCHER
+#!/bin/sh
+if [ "\$1" = "--version" ]; then echo "0.9.9"; exit 0; fi
+echo "usage probe ok"
+LAUNCHER
+  chmod +x "$payload/bin/hive"
+  cp -R "$REPO_ROOT/lib" "$payload/share/hive/" 2>/dev/null || true
+
+  tar -czf "$FAKE_RELEASE/hive-v0.9.9-linux-x86_64.tar.gz" -C "$payload/.." "$(basename "$payload")"
+  (
+    cd "$FAKE_RELEASE"
+    sha256sum hive-v0.9.9-linux-x86_64.tar.gz > SHA256SUMS
+  )
+}
+
+fail_count=0
+
+# ── Scenario 5 + 1: pinned offline install runs and answers --version ──
+build_fixture_release
+run_installer > "$TMP/install.log" 2>&1 || { cat "$TMP/install.log" >&2; exit 1; }
+assert_file "$SANDBOX_HOME/.local/bin/hive" "launcher symlink"
+[[ "$("$SANDBOX_HOME/.local/bin/hive" --version)" == "0.9.9" ]] || { echo FAIL version; exit 1; }
+pass "installer answeres --version (pinned v0.9.9)"
+grep -q "channel: script" "$SANDBOX_HOME/.config/hive/install.yml" ||
+  { echo "FAIL receipt"; exit 1; }
+pass "receipt written with channel: script"
+
+# Uninstall reverses launcher but preserves config/state.
+bash "$INSTALL_SH" --uninstall >/dev/null 2>&1
+[[ ! -e "$SANDBOX_HOME/.local/bin/hive" ]] || { echo "FAIL uninstall left launcher"; exit 1; }
+[[ -d "$SANDBOX_HOME/.local/share/hive" ]] || { echo "FAIL uninstall removed app tree (should keep data semantics on data categories here)"; exit 1; }
+pass "uninstall removes launchers only"
+
+# Reinstall for later scenarios.
+run_installer >/dev/null 2>&1
+
+# ── Scenario 4: tampered tarball hard-fails with zero writes ───────────
+cp "$FAKE_RELEASE/hive-v0.9.9-linux-x86_64.tar.gz" "$FAKE_RELEASE/hive-bad.tar.gz"
+printf 'tamper' >> "$FAKE_RELEASE/hive-bad.tar.gz"
+sed -i 's|hive-v0.9.9-linux-x86_64.tar.gz|hive-bad.tar.gz|' /dev/null 2>/dev/null || true
+cat >> "$FAKE_RELEASE/SHA256SUMS.bad" <<EOF
+0000000000000000000000000000000000000000000000000000000000000000  hive-v0.9.9-linux-x86_64.tar.gz
+EOF
+mv "$FAKE_RELEASE/SHA256SUMS" "$FAKE_RELEASE/SHA256SUMS.good"
+cp "$FAKE_RELEASE/SHA256SUMS.bad" "$FAKE_RELEASE/SHA256SUMS"
+LAUNCHER_TARGET_BEFORE="$(readlink "$SANDBOX_HOME/.local/bin/hive" || true)"
+APP_DIR_MTIME_BEFORE="$(stat -c %Y "$SANDBOX_HOME/.local/share/hive/bin/hive" 2>/dev/null || true)"
+if run_installer > "$TMP/tamper.log" 2>&1; then
+  echo "FAIL: installer accepted a tampered artifact"; exit 1
+fi
+grep -q "CHECKSUM MISMATCH" "$TMP/tamper.log" || { echo "FAIL wrong error text"; exit 1; }
+LAUNCHER_TARGET_AFTER="$(readlink "$SANDBOX_HOME/.local/bin/hive" || true)"
+[[ "$LAUNCHER_TARGET_BEFORE" == "$LAUNCHER_TARGET_AFTER" ]] ||
+  { echo "FAIL: launcher changed despite checksum failure"; exit 1; }
+mv "$FAKE_RELEASE/SHA256SUMS.good" "$FAKE_RELEASE/SHA256SUMS"
+rm -f "$FAKE_RELEASE/SHA256SUMS.bad"
+pass "checksum mismatch refuses and writes nothing"
+
+# ── Scenario 3: PATH conflict stub installs as hv ───────────────────────
+CONFLICT_BIN="$TMP/conflict-bin"
+mkdir -p "$CONFLICT_BIN"
+cat > "$CONFLICT_BIN/hive" <<STUB
+#!/bin/sh
+echo "Apache Hive (stub)"
+STUB
+chmod +x "$CONFLICT_BIN/hive"
+HIVE_OUT=$(PATH="$CONFLICT_BIN:$PATH" run_installer)
+echo "$HIVE_OUT" | grep -q "installing as 'hv'" || { echo "FAIL hv fallback missing"; exit 1; }
+[[ -x "$SANDBOX_HOME/.local/bin/hv" ]] || { echo "FAIL hv not installed"; exit 1; }
+pass "Apache Hive collision falls back to hv"
+
+printf '\ninstall_test: all scenarios green\n'
diff --git a/test/packaging/smoke_tarball.sh b/test/packaging/smoke_tarball.sh
new file mode 100755
index 0000000..893fdf8
--- /dev/null
+++ b/test/packaging/smoke_tarball.sh
@@ -0,0 +1,38 @@
+#!/usr/bin/env bash
+# test/packaging/smoke_tarball.sh — verify a built hive release tarball
+# (plan U3 test scenario 1: extracted in a Ruby-less sandbox, runs
+# `hive --version` and `hive status --json`; scenario 3: SHA256SUMS verifies).
+#
+# Usage: smoke_tarball.sh <path-to-tar.gz>
+set -euo pipefail
+
+ARTIFACT="${1:?usage: smoke_tarball.sh <hive-<semver>-<os>-<arch>.tar.gz>}"
+[[ -f "$ARTIFACT" ]] || { echo "no such artifact: $ARTIFACT" >&2; exit 1; }
+
+WORK="$(mktemp -d "${TMPDIR:-/tmp}/hive-smoke.XXXXXX")"
+trap 'rm -rf "$WORK"' EXIT
+
+echo "[smoke] verifying checksum manifest"
+tar -xzf "$ARTIFACT" -C "$WORK"
+ROOT="$(cd "$WORK"/*/ && pwd)"
+(
+  cd "$ROOT"
+  sha256sum -c SHA256SUMS --quiet
+)
+
+echo "[smoke] running bin/hive --version from extraction root"
+"$ROOT/bin/hive" --version | grep -E '^0\.[0-9]+\.[0-9]+' || {
+  echo "FAIL: bin/hive --version did not print a semver" >&2; exit 1;
+}
+
+echo "[smoke] running hive status --json in an isolated HIVE_HOME"
+HIVE_HOME="$(mktemp -d "${TMPDIR:-/tmp}/hive-home.XXXXXX")" \
+  "$ROOT/bin/hive" status --json >/dev/null
+
+if [[ -x "$ROOT/embedded-ruby/bin/ruby" ]]; then
+  echo "[smoke] portable backend detected — embedded runtime used for the above checks"
+else
+  echo "[smoke] dev/system-ruby build — embedded runtime absent (expected locally)"
+fi
+
+echo "[smoke] OK"
diff --git a/test/smoke/live_claude_smoke_test.rb b/test/smoke/live_claude_smoke_test.rb
index 738b2b3..ff485bd 100644
--- a/test/smoke/live_claude_smoke_test.rb
+++ b/test/smoke/live_claude_smoke_test.rb
@@ -43,10 +43,10 @@ class LiveClaudeSmokeTest < Minitest::Test
         project = File.basename(dir)
         capture_io { Hive::Commands::New.new(project, "add a contributing note").call }
 
-        slug = File.basename(Dir[File.join(dir, ".hive-state", "stages", "1-inbox", "*")].first)
-        brainstorm_dir = File.join(dir, ".hive-state", "stages", "2-brainstorm", slug)
+        slug = File.basename(Dir[File.join(dir, ".hive", "stages", "1-inbox", "*")].first)
+        brainstorm_dir = File.join(dir, ".hive", "stages", "2-brainstorm", slug)
         FileUtils.mkdir_p(File.dirname(brainstorm_dir))
-        FileUtils.mv(File.join(dir, ".hive-state", "stages", "1-inbox", slug), brainstorm_dir)
+        FileUtils.mv(File.join(dir, ".hive", "stages", "1-inbox", slug), brainstorm_dir)
 
         Hive::Commands::Run.new(brainstorm_dir).call
 
@@ -71,10 +71,10 @@ class LiveClaudeSmokeTest < Minitest::Test
         project = File.basename(dir)
         capture_io { Hive::Commands::New.new(project, "smoke injection probe").call }
 
-        slug = File.basename(Dir[File.join(dir, ".hive-state", "stages", "1-inbox", "*")].first)
-        brainstorm_dir = File.join(dir, ".hive-state", "stages", "2-brainstorm", slug)
+        slug = File.basename(Dir[File.join(dir, ".hive", "stages", "1-inbox", "*")].first)
+        brainstorm_dir = File.join(dir, ".hive", "stages", "2-brainstorm", slug)
         FileUtils.mkdir_p(File.dirname(brainstorm_dir))
-        FileUtils.mv(File.join(dir, ".hive-state", "stages", "1-inbox", slug), brainstorm_dir)
+        FileUtils.mv(File.join(dir, ".hive", "stages", "1-inbox", slug), brainstorm_dir)
         # Replace idea.md with hostile content so the brainstorm prompt is built
         # around it. The nonce wrapper must contain it as data.
         File.write(File.join(brainstorm_dir, "idea.md"), HOSTILE_IDEA)
diff --git a/test/smoke/live_review_smoke_test.rb b/test/smoke/live_review_smoke_test.rb
index 3eb8a58..b6fccb8 100644
--- a/test/smoke/live_review_smoke_test.rb
+++ b/test/smoke/live_review_smoke_test.rb
@@ -44,10 +44,10 @@ class LiveReviewSmokeTest < Minitest::Test
         # Move the task into 6-review/ with a worktree.yml + a tiny diff
         # against the default branch, so the reviewer has SOMETHING to look
         # at without being so complex it generates findings.
-        slug = File.basename(Dir[File.join(project_dir, ".hive-state", "stages", "1-inbox", "*")].first)
-        review_dir = File.join(project_dir, ".hive-state", "stages", "6-review", slug)
+        slug = File.basename(Dir[File.join(project_dir, ".hive", "stages", "1-inbox", "*")].first)
+        review_dir = File.join(project_dir, ".hive", "stages", "6-review", slug)
         FileUtils.mkdir_p(File.dirname(review_dir))
-        FileUtils.mv(File.join(project_dir, ".hive-state", "stages", "1-inbox", slug), review_dir)
+        FileUtils.mv(File.join(project_dir, ".hive", "stages", "1-inbox", slug), review_dir)
 
         worktree_root = File.join(project_dir, ".worktrees")
         worktree_path = File.join(worktree_root, slug)
@@ -106,6 +106,6 @@ class LiveReviewSmokeTest < Minitest::Test
         "browser" => { "enabled" => false }
       }
     }
-    File.write(File.join(project_dir, ".hive-state", "config.yml"), cfg.to_yaml)
+    File.write(File.join(project_dir, ".hive", "config.yml"), cfg.to_yaml)
   end
 end
diff --git a/test/test_helper.rb b/test/test_helper.rb
index d251d52..442fa6b 100644
--- a/test/test_helper.rb
+++ b/test/test_helper.rb
@@ -28,6 +28,11 @@ end
 
 Minitest::Test.include(HiveTestStdinIsolation)
 
+# U5 safety: hive init's post-scaffold service registration must never
+# touch a developer/host's real launchd/systemd during tests.
+default_hive_no_service = { "HIVE_NO_SERVICE" => "1" }
+default_hive_no_service.each { |k, v| ENV[k] ||= v unless ENV.key?(k) }
+
 # Shared fixture paths for tests. Constants here so a future move of
 # test/fixtures lands in one place instead of every test that needs
 # fake-gh / fake-claude. Use as `FAKE_GH_FIXTURE` / `FAKE_CLAUDE_FIXTURE`.
diff --git a/test/unit/agent_profile_modes_test.rb b/test/unit/agent_profile_modes_test.rb
index 4ed1a88..5d87dee 100644
--- a/test/unit/agent_profile_modes_test.rb
+++ b/test/unit/agent_profile_modes_test.rb
@@ -33,7 +33,7 @@ class AgentProfileModesTest < Minitest::Test
   end
 
   def make_task(dir, stage = "2-brainstorm", slug = "agent-modes-260425-aaaa")
-    folder = File.join(dir, ".hive-state", "stages", stage, slug)
+    folder = File.join(dir, ".hive", "stages", stage, slug)
     FileUtils.mkdir_p(folder)
     Hive::Task.new(folder)
   end
diff --git a/test/unit/agent_test.rb b/test/unit/agent_test.rb
index 8d81297..4680e52 100644
--- a/test/unit/agent_test.rb
+++ b/test/unit/agent_test.rb
@@ -23,7 +23,7 @@ class AgentTest < Minitest::Test
   end
 
   def make_task(dir, stage = "2-brainstorm", slug = "agent-test-260424-aaaa")
-    folder = File.join(dir, ".hive-state", "stages", stage, slug)
+    folder = File.join(dir, ".hive", "stages", stage, slug)
     FileUtils.mkdir_p(folder)
     Hive::Task.new(folder)
   end
diff --git a/test/unit/bot/brainstorm_answer_writer_test.rb b/test/unit/bot/brainstorm_answer_writer_test.rb
index 473a870..e7d68e4 100644
--- a/test/unit/bot/brainstorm_answer_writer_test.rb
+++ b/test/unit/bot/brainstorm_answer_writer_test.rb
@@ -8,7 +8,7 @@ class HiveBotBrainstormAnswerWriterTest < Minitest::Test
 
   def with_brainstorm(content)
     with_tmp_dir do |dir|
-      folder = File.join(dir, ".hive-state", "stages", "2-brainstorm", "slug-260514-abcd")
+      folder = File.join(dir, ".hive", "stages", "2-brainstorm", "slug-260514-abcd")
       FileUtils.mkdir_p(folder)
       path = File.join(folder, "brainstorm.md")
       File.write(path, content)
diff --git a/test/unit/bot/codex_conversation_test.rb b/test/unit/bot/codex_conversation_test.rb
index 91f0438..48b5703 100644
--- a/test/unit/bot/codex_conversation_test.rb
+++ b/test/unit/bot/codex_conversation_test.rb
@@ -22,7 +22,7 @@ class HiveBotCodexConversationTest < Minitest::Test
 
   def with_task
     with_tmp_dir do |dir|
-      folder = File.join(dir, ".hive-state", "stages", "2-brainstorm", "slug-260514-abcd")
+      folder = File.join(dir, ".hive", "stages", "2-brainstorm", "slug-260514-abcd")
       FileUtils.mkdir_p(folder)
       File.write(File.join(folder, "brainstorm.md"), "")
       yield Hive::Task.new(folder)
diff --git a/test/unit/bot/router_test.rb b/test/unit/bot/router_test.rb
index 27fec7c..c57f8b0 100644
--- a/test/unit/bot/router_test.rb
+++ b/test/unit/bot/router_test.rb
@@ -8,8 +8,8 @@ class HiveBotRouterTest < Minitest::Test
     @logger = StubLogger.new
     @store = Hive::Bot::ConversationStore.new
     @projects = [
-      { "name" => "hive", "path" => "/tmp/hive", "hive_state_path" => "/tmp/hive/.hive-state" },
-      { "name" => "writero", "path" => "/tmp/writero", "hive_state_path" => "/tmp/writero/.hive-state" }
+      { "name" => "hive", "path" => "/tmp/hive", "hive_state_path" => "/tmp/hive/.hive" },
+      { "name" => "writero", "path" => "/tmp/writero", "hive_state_path" => "/tmp/writero/.hive" }
     ]
     @router = Hive::Bot::Router.new(
       bot_config: { "chat_id_allowlist" => [ 12345 ] },
diff --git a/test/unit/bot/status_watcher_test.rb b/test/unit/bot/status_watcher_test.rb
index 193b198..aee9b8c 100644
--- a/test/unit/bot/status_watcher_test.rb
+++ b/test/unit/bot/status_watcher_test.rb
@@ -33,7 +33,7 @@ class HiveBotStatusWatcherTest < Minitest::Test
         {
           "name" => "hive",
           "path" => "/tmp/hive",
-          "hive_state_path" => "/tmp/hive/.hive-state",
+          "hive_state_path" => "/tmp/hive/.hive",
           "tasks" => tasks
         }
       ]
@@ -44,8 +44,8 @@ class HiveBotStatusWatcherTest < Minitest::Test
     {
       "stage" => "2-brainstorm",
       "slug" => slug,
-      "folder" => "/tmp/hive/.hive-state/stages/2-brainstorm/#{slug}",
-      "state_file" => "/tmp/hive/.hive-state/stages/2-brainstorm/#{slug}/brainstorm.md",
+      "folder" => "/tmp/hive/.hive/stages/2-brainstorm/#{slug}",
+      "state_file" => "/tmp/hive/.hive/stages/2-brainstorm/#{slug}/brainstorm.md",
       "marker" => marker,
       "attrs" => attrs,
       "mtime" => Time.now.utc.iso8601,
diff --git a/test/unit/commands/daemon_envelope_test.rb b/test/unit/commands/daemon_envelope_test.rb
index 4e27029..1ac4a8f 100644
--- a/test/unit/commands/daemon_envelope_test.rb
+++ b/test/unit/commands/daemon_envelope_test.rb
@@ -101,7 +101,7 @@ class HiveCommandsDaemonEnvelopeTest < Minitest::Test
   def test_unexpected_error_after_preflight_emits_internal_envelope
     Dir.mktmpdir("hive-envelope-test") do |home|
       project_root = File.join(home, "proj")
-      hive_state = File.join(project_root, ".hive-state")
+      hive_state = File.join(project_root, ".hive")
       FileUtils.mkdir_p(hive_state)
       File.write(File.join(hive_state, "config.yml"), "default_branch: main\n")
       File.write(File.join(home, "config.yml"), {
@@ -155,7 +155,7 @@ class HiveCommandsDaemonEnvelopeTest < Minitest::Test
 
     Dir.mktmpdir("hive-envelope-test") do |home|
       project_root = File.join(home, "proj")
-      hive_state = File.join(project_root, ".hive-state")
+      hive_state = File.join(project_root, ".hive")
       FileUtils.mkdir_p(hive_state)
       cfg_path = File.join(hive_state, "config.yml")
       File.write(cfg_path, "default_branch: main\n")
diff --git a/test/unit/commands/doctor_system_deps_test.rb b/test/unit/commands/doctor_system_deps_test.rb
new file mode 100644
index 0000000..33a5d08
--- /dev/null
+++ b/test/unit/commands/doctor_system_deps_test.rb
@@ -0,0 +1,110 @@
+require "test_helper"
+require "hive/commands/doctor"
+require "hive/commands/init"
+
+# U4 (plan figure-out-way-to-install-260513-4a0a): system dependency
+# probes inside `hive doctor` — hard deps (git/bash) gate `hive init`,
+# warn deps (claude/codex/pi/gh/jq) never block, version floors report
+# version_too_old, and every row carries the shared envelope fields so
+# the prompt installer can consume `hive doctor --json`.
+class HiveCommandsDoctorSystemDepsTest < Minitest::Test
+  include HiveTestHelper
+
+  def rows_for(path_env:)
+    out = StringIO.new
+    saved = ENV["PATH"]
+    ENV["PATH"] = path_env
+    Hive::Commands::Doctor
+      .new(config: {}, project_root: Dir.pwd, output: out)
+      .send(:check_system_dependencies)
+  ensure
+    ENV["PATH"] = saved
+  end
+
+  def bin_dirs(*names)
+    # Builds a PATH out of the dirs actually containing the given binaries,
+    # proving resolution only finds what it should.
+    names.map { |n| File.dirname(find_real_bin(n)) }.uniq.join(":")
+  end
+
+  def find_real_bin(name)
+    ENV.fetch("PATH", "").split(File::PATH_SEPARATOR).map { |d| File.join(d, name) }
+       .find { |p| File.file?(p) && File.executable?(p) } || "/nonexistent/#{name}"
+  end
+
+  def test_hard_rows_report_missing_with_distro_hint_when_bin_absent
+    dirs = bin_dirs("bash") # git intentionally omitted where possible; skip if same dir
+    if File.dirname(find_real_bin("git")) == File.dirname(find_real_bin("bash"))
+      skip("git and bash share a directory; cannot construct isolated PATH")
+    end
+
+    rows = rows_for(path_env: dirs)
+    git = rows.find { |r| r[:label] == "system/git" }
+    assert_equal "missing", git[:status]
+    assert_match(/install it with /, git[:message])
+    assert_match(/hive init.*aborts|aborts/, git[:message])
+  end
+
+  def test_warn_row_for_missing_gh_does_not_fail
+    dirs = bin_dirs("git", "bash")
+    rows = rows_for(path_env: dirs)
+    gh = rows.find { |r| r[:label] == "github/gh" }
+    refute_nil gh
+    assert_equal "warning", gh[:status]
+    jq = rows.find { |r| r[:label] == "tooling/jq" }
+    assert_equal "warning", jq[:status]
+  end
+
+  def test_version_floor_flags_only_old_versions
+    doctor = Hive::Commands::Doctor.new(config: {}, project_root: Dir.pwd, output: StringIO.new)
+    assert_predicate doctor.send(:version_below?, "2.1.117", "2.1.118"), :itself
+    refute_predicate doctor.send(:version_below?, "2.1.118", "2.1.118"), :itself
+    refute_predicate doctor.send(:version_below?, "0.142.2", "0.125.0"), :itself
+    refute_predicate doctor.send(:version_below?, "0.84.2", "0.70.2"), :itself
+  end
+
+  def test_unsatisfied_hard_dependencies_gate_returns_empty_on_healthy_path
+    result = Hive::Commands::Doctor.unsatisfied_hard_dependencies
+    assert_empty(result, "this machine has git+bash; gate must pass")
+  end
+
+  def test_dependency_rows_carry_envelope_fields
+    out = StringIO.new
+    doctor = Hive::Commands::Doctor.new(config: {}, project_root: Dir.pwd, output: out)
+    doctor.send(:check_system_dependencies)
+
+    row_keys = %i[kind stage label agent configured_skill skill status message]
+    all_have = true
+    doctor.call # recompute via public surface into @rows
+    (doctor.rows || []).select { |r| r[:kind] == "dependency" }.each do |r|
+      missing_fields = row_keys - r.keys
+      all_have &&= missing_fields.empty?
+    end
+    assert all_have, "every dependency row must expose the envelope field set"
+  end
+
+  def test_init_gate_aborts_before_any_disk_writes_when_git_absent
+    # Simulated by a stubbed unsatisfied_hard_dependencies returning one
+    # row — proves ordering: no scaffold work happens.
+    calls = []
+    Hive::Commands::Doctor.singleton_class.send(:alias_method, :real_gate, :unsatisfied_hard_dependencies)
+    Hive::Commands::Doctor.define_singleton_method(:unsatisfied_hard_dependencies) do |*|
+      [{ label: "system/git", message: "git not found — install it with brew install git" }]
+    end
+    begin
+      with_tmp_git_repo do |dir|
+        _out, err, code = with_captured_exit do
+          Hive::Commands::Init.new(dir).call
+        end
+        calls << dir
+        assert_equal 1, code
+        assert_match(/required system dependencies are missing/, err)
+        assert_empty(Dir[File.join(dir, ".hive", "**/*")], "zero disk side effects")
+        branches = `git -C #{dir} branch --list`
+        refute_includes(branches, "hive/state")
+      end
+    ensure
+      Hive::Commands::Doctor.singleton_class.send(:alias_method, :unsatisfied_hard_dependencies, :real_gate)
+    end
+  end
+end
diff --git a/test/unit/commands/doctor_test.rb b/test/unit/commands/doctor_test.rb
index e54f4fd..6324e89 100644
--- a/test/unit/commands/doctor_test.rb
+++ b/test/unit/commands/doctor_test.rb
@@ -142,11 +142,13 @@ class HiveCommandsDoctorTest < Minitest::Test
 
       env = JSON.parse(out.string)
       assert_equal "hive-doctor.v1", env["schema"]
-      assert_equal 2, env["checks"].length
+      # System-dependency rows (U4) are machine-dependent; the stable
+      # contract is that the two stage rows are present.
+      stage_rows = env["checks"].select { |c| c["kind"] == "stage" }
+      assert_equal 2, stage_rows.length
       assert_equal 1, env["summary"]["missing"]
-      assert_equal 1, env["summary"]["present"]
-      assert(env["checks"].any? { |c| c["stage"] == "plan" && c["status"] == "present" })
-      assert(env["checks"].any? { |c| c["stage"] == "brainstorm" && c["status"] == "missing" })
+      assert(stage_rows.any? { |c| c["stage"] == "plan" && c["status"] == "present" })
+      assert(stage_rows.any? { |c| c["stage"] == "brainstorm" && c["status"] == "missing" })
     end
   end
 
@@ -286,10 +288,11 @@ class HiveCommandsDoctorTest < Minitest::Test
         Hive::Commands::Doctor.new(config: cfg, project_root: nil, json: true, output: out).call
 
         env = JSON.parse(out.string)
-        warning = env.fetch("checks").find { |check| check["status"] == "warning" }
-        assert_equal 1, env.fetch("summary").fetch("warning")
-        assert_equal "billing-auth", warning.fetch("configured_skill")
-        assert_equal "ANTHROPIC_API_KEY", warning.fetch("skill")
+        billing = env.fetch("checks").find { |check| check["configured_skill"] == "billing-auth" }
+        refute_nil billing
+        assert_equal "ANTHROPIC_API_KEY", billing.fetch("skill")
+        # Machine-dependent warn-tier dependencies (gh/jq) may add more
+        # warning rows; the billing row is asserted directly above.
       end
     end
   ensure
@@ -497,12 +500,13 @@ class HiveCommandsDoctorTest < Minitest::Test
 
       env = JSON.parse(out.string)
       assert_equal "hive-doctor.v1", env["schema"]
-      assert_equal 3, env["checks"].length
 
       stage_entries = env["checks"].select { |c| c["kind"] == "stage" }
       reviewer_entries = env["checks"].select { |c| c["kind"] == "reviewer" }
+      dependency_entries = env["checks"].select { |c| c["kind"] == "dependency" }
       assert_equal 2, stage_entries.length
       assert_equal 1, reviewer_entries.length
+      assert dependency_entries.is_a?(Array)
 
       stage_entries.each do |c|
         assert c.key?("label"), "every stage entry has :label"
